using System;
using System.Collections.Generic;
using System.Collections;
using System.Text;
using System.Collections.Specialized;
using Microsoft.Practices.EnterpriseLibrary.Caching.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration.ObjectBuilder;
using Microsoft.Practices.EnterpriseLibrary.Caching;

namespace CachingCoreTests
{
    [ConfigurationElementType(typeof(CustomCacheStorageData))]
    public class MockBackingStore : IBackingStore
    {
        public static NameValueCollection attributes;
        public static int count;
        public MockBackingStore(NameValueCollection attributes)
			
		{
            MockBackingStore.attributes = attributes;
		}

		public int Count
		{
            get { return count; }
		}

		public void Add(CacheItem newCacheItem)
		{
			count++;
		}

		public void Remove(string key)
		{
			count--;
		}

		public void UpdateLastAccessedTime(string key, DateTime timestamp)
		{
			
		}

		public void Flush()
		{
			count = 0;
		}

		public Hashtable Load()
		{
            Hashtable items = new Hashtable();
            return items;
		}

		public void Dispose()
		{
			
		}
    }
}
