using System;
using Microsoft.Practices.EnterpriseLibrary.Caching;
using Microsoft.Practices.EnterpriseLibrary.Caching.Expirations;
using Microsoft.Practices.EnterpriseLibrary.Common.Instrumentation;
using System.Diagnostics;
#if !NUNIT
using Microsoft.VisualStudio.TestTools.UnitTesting;
#else
using NUnit.Framework;
using TestClass = NUnit.Framework.TestFixtureAttribute;
using TestInitialize = NUnit.Framework.SetUpAttribute;
using TestCleanup = NUnit.Framework.TearDownAttribute;
using TestMethod = NUnit.Framework.TestAttribute;
#endif
namespace CachingCoreTests
{
    /// <summary>
    /// Summary description for MockCachingTestFixture
    /// </summary>
    [TestClass]
    public class MockCachingTestFixture
    {
        public MockCachingTestFixture()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [TestMethod]
        public void MockStoreAddTest()
        {
            CacheManager itemCache = CacheFactory.GetCacheManager("CustomCacheManager");
            itemCache.Add("1", "test");
            string cacheData = (string) itemCache.GetData("1");
            Assert.AreEqual("test", cacheData);
            Assert.AreEqual(3, MockBackingStore.attributes.Count);
            Assert.AreEqual("1", MockBackingStore.attributes["itemid"]);
            Assert.AreEqual("Item1", MockBackingStore.attributes["itemdescription"]);
            Assert.AreEqual("28.75", MockBackingStore.attributes["itemprice"]);
        }
    }
}
