using Microsoft.Practices.EnterpriseLibrary.Common.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Caching.BackingStoreImplementations;

namespace CachingCoreTests
{
    [ConfigurationElementType(typeof(MockEncryptionProviderData))]
	public class MockEncryptionProvider : IStorageEncryptionProvider
	{
		public static bool Encrypted;
		public static bool Decrypted;

        public MockEncryptionProvider()
		{
		}

		public byte[] Encrypt(byte[] plaintext)
		{
			Encrypted = true;
			return plaintext;
		}

		public byte[] Decrypt(byte[] ciphertext)
		{
			Decrypted = true;
			return ciphertext;
		}
	}
}
