using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Common.Instrumentation; 
using ConfigurationCoreTests.Configuration; 
namespace ConfigurationCoreTests
{
    [ConfigurationElementType(typeof(ItemData))]           
    public class CommonItem:IItem,IInstrumentationEventProvider 
    {
        private decimal Price;
        private int Quantity;
        private ItemInstrumentationProvider instrumentationProvider;

        public CommonItem(decimal Price, int Quantity)
        {
            this.Price = Price;
            this.Quantity = Quantity;
            instrumentationProvider = new ItemInstrumentationProvider(); 
        }
    
        public decimal CalculateTotal()
        {
            try
            {
                decimal total = Price * Quantity;
                if (Quantity <= 0) throw new Exception("The quantity value should be greater than zero"); 
                instrumentationProvider.FireItemCalculatedEvent();
                return (total);
            }
            catch (Exception e)
            {
                instrumentationProvider.FireErrorCalculating(e);
                return 0;
            }
        }

        public object GetInstrumentationEventProvider()
        {
            return instrumentationProvider; 
        }

    }
}
