using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration.ObjectBuilder;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration;
using Microsoft.Practices.ObjectBuilder;
using System.Reflection;
using ConfigurationCoreTests.Configuration;        
namespace ConfigurationCoreTests
{
    class ItemCustomFactory:ICustomFactory
    {
        public object CreateObject(IBuilderContext context, string name, IConfigurationSource configurationSource, ConfigurationReflectionCache reflectionCache)
        {
            ItemSettings setting = (ItemSettings)configurationSource.GetSection("itemConfiguration");
            ItemData itemData = (ItemData)setting.Items.Get(name);
            ConfigurationElementTypeAttribute attrib = reflectionCache.GetCustomAttribute<ConfigurationElementTypeAttribute>(itemData.Type);
            AssemblerAttribute assemblerAttrib = reflectionCache.GetCustomAttribute<AssemblerAttribute>(attrib.ConfigurationType);
            IAssembler<IItem, ItemData> assembler = (IAssembler<IItem, ItemData>)Activator.CreateInstance(assemblerAttrib.AssemblerType);
            return assembler.Assemble(context, itemData, configurationSource, reflectionCache);      
        }
    }
}
