using System;
using System.Text;
using System.Collections.Generic;
using System.Threading;
using System.Data.SqlClient;
using Microsoft.Practices.EnterpriseLibrary.Data;
using System.Data.Common;
using System.Data;
using System.Configuration;
//#if VSTS
#if !NUNIT
using Microsoft.VisualStudio.TestTools.UnitTesting;
#else
using NUnit.Framework;
using TestClass = NUnit.Framework.TestFixtureAttribute;
using TestInitialize = NUnit.Framework.SetUpAttribute;
using TestCleanup = NUnit.Framework.TearDownAttribute;
using TestMethod = NUnit.Framework.TestAttribute;
#endif

//#else
//using NUnit.Framework;
//using TestClass = NUnit.Framework.TestFixtureAttribute;
//using TestInitialize = NUnit.Framework.SetUpAttribute;
//using TestCleanup = NUnit.Framework.TearDownAttribute;
//using TestMethod = NUnit.Framework.TestAttribute;
//#endif

namespace DataFuncTests.SqlDatabaseFixtures
{
    /// <summary>
    /// Summary description for MultiThreadTest
    /// </summary>
    [TestClass]
    public class MultiThreadTest
    {
        private volatile int i = 0;
        private const int NoOfThreads = 50;
        string connStr;
        int count = 0;
        public MultiThreadTest()
        {
        }

        [TestInitialize]
        public void Initialize()
        {
            connStr = ConfigurationManager.ConnectionStrings["DataSQLTest"].ConnectionString;
            SqlConnection conn = new SqlConnection();
            conn.ConnectionString = connStr;
            conn.Open();
            SqlCommand cmd = new SqlCommand("select count(*) from Items ", conn);
            count = (int)cmd.ExecuteScalar();
            conn.Close();
        }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion
      
         
        [TestMethod]
        public void CreateDatabaseMultipleTimes()
        {
            Thread[] thread = new Thread[NoOfThreads];
            for (int i = 0 ; i < NoOfThreads; i++)
            {
                thread[i] = new Thread(new ThreadStart(MultiThreadMethod));
            }
            for (int i = 0; i < NoOfThreads; i++)
            {
                thread[i].Start();
                thread[i].Join();
            }
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            int rows = (int)db.ExecuteScalar(CommandType.Text, "select count(*) from Items");
            Assert.AreEqual (NoOfThreads, (rows - count));
        }

        public void MultiThreadMethod()
        {
            i = i + count + 1;
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DbCommand dbCmd = db.GetStoredProcCommand("AddItem");
            db.AddInParameter(dbCmd,"@ItemID", DbType.Int32,i);
            db.AddInParameter(dbCmd, "@ItemDescription", DbType.String,"Item");
            db.AddInParameter(dbCmd, "@Price", DbType.Int16, 100);
            db.AddInParameter(dbCmd, "@QtyInHand", DbType.Int16, 1);
            db.AddInParameter(dbCmd, "@QtyRequired", DbType.Int16, 1);
            db.ExecuteNonQuery(dbCmd);    
        }
    }
}
