using System;
#if !NUNIT
using Microsoft.VisualStudio.TestTools.UnitTesting;
#else
using NUnit.Framework;
using TestClass = NUnit.Framework.TestFixtureAttribute;
using TestInitialize = NUnit.Framework.SetUpAttribute;
using TestCleanup = NUnit.Framework.TearDownAttribute;
using TestMethod = NUnit.Framework.TestAttribute;
#endif
//using Microsoft.Practices.EnterpriseLibrary.Data.Instrumentation;
using System.Management;
using Microsoft.Practices.EnterpriseLibrary.Data;
using Microsoft.Practices.EnterpriseLibrary.Data.Sql;
using System.Data;
using System.Data.SqlClient;
using System.Data.Sql;
using System.Threading;
using Microsoft.Practices.EnterpriseLibrary.Common;
using System.Data.Common;
namespace DataFuncTests.DataSQLServerTests
{
    /// <summary>
    /// Summary description for WMIEventsTestFixture
    /// </summary>
    [TestClass]
    public class WMIEventsTestFixture
    {
        String connStr = "";
        String wmiText = "";
        String expectedConnStr = "";
        bool wmiLogged = false;
        private ManagementScope scope = new ManagementScope(@"\\.\root\EnterpriseLibrary");

        public WMIEventsTestFixture()
        {
            //
            // TODO: Add constructor logic here
            //
        }
        /// <summary>
        /// Initialize() is called once during test execution before
        /// test methods in this test class are executed.
        /// </summary>
        [TestInitialize()]
        public void Initialize()
        {
            scope.Options.EnablePrivileges = true;
            connStr = "server=(local)\\SQLEXPRESS;initial catalog=TestDatabase;integrated security=SSPI";
            SqlConnection conn = new SqlConnection();
            conn.ConnectionString = connStr;
            conn.Open();
            SqlCommand cmd = new SqlCommand("begin Delete from Items where itemId > 3 " +
                                            "end", conn);
            cmd.ExecuteNonQuery();
            conn.Close();
        }
        /// <summary>
        /// Cleanup() is called once during test execution after
        /// test methods in this class have executed unless the
        /// corresponding Initialize() call threw an exception.
        /// </summary>
        [TestCleanup()]
        public void Cleanup()
        {
            //  TODO: Add test cleanup code
        }
        [TestMethod]
        public void DataCommandFailedEventTest()
        {
            wmiLogged = false;
            wmiText = "";
            EventQuery eq = new EventQuery("SELECT * FROM CommandFailedEvent");
            ManagementEventWatcher watcher = new ManagementEventWatcher(scope, eq);
            watcher.EventArrived += new EventArrivedEventHandler(WatcherEventArrived);
            watcher.Start();
            Database db = DatabaseFactory.CreateDatabase();
            string sqlCommand = "Select ItemDescription from Item order by ItemId";
            try
            {
                DbCommand dbCommandWrapper = db.GetSqlStringCommand(sqlCommand);
                using (IDataReader dataReader = db.ExecuteReader(dbCommandWrapper))
                {
                }
            }
            catch (Exception)
            {
            }
            Thread.Sleep(2000);
            watcher.EventArrived -= new EventArrivedEventHandler(WatcherEventArrived);
            watcher.Stop();
            Assert.AreEqual(true, wmiLogged);
            if (wmiText.IndexOf(sqlCommand) == -1 || wmiText.IndexOf("CommandFailedEvent") == -1)
            {
                Assert.Fail();
            }
        }

        [TestMethod]
        public void DataConnectionFailedEventTest()
        {
            wmiLogged = false;
            wmiText = "";
            EventQuery eq = new EventQuery("SELECT * FROM ConnectionFailedEvent");
            ManagementEventWatcher watcher = new ManagementEventWatcher(scope, eq);
            watcher.EventArrived += new EventArrivedEventHandler(WatcherEventArrived);
            watcher.Start();
            try
            {
                Database db = DatabaseFactory.CreateDatabase("DBDoesNotExist");
                string sqlCommand = "select ItemDescription from items where ItemID=1";
                DbCommand dbCommandWrapper = db.GetSqlStringCommand(sqlCommand);
                object actualResult = db.ExecuteScalar(CommandType.Text, sqlCommand);
            }
            catch (Exception)
            {
            }
            Thread.Sleep(2000);
            watcher.EventArrived -= new EventArrivedEventHandler(WatcherEventArrived);
            watcher.Stop();
            Assert.AreEqual(true, wmiLogged);
            if (wmiText.IndexOf(expectedConnStr) == -1 || wmiText.IndexOf("ConnectionFailedEvent") == -1)
            {
                Assert.Fail();
            }
        }

        private void WatcherEventArrived(object sender, EventArrivedEventArgs args)
        {
            wmiLogged = true;
            /// Validate the message here
            wmiText = args.NewEvent.GetText(TextFormat.Mof);
        }
        # region Helper Method
        private void CreateCommandParameter(Database db,DbCommand comm, string Parametername, DbType dbType, ParameterDirection dir, string SrcColumn, DataRowVersion rowVersion)
        {

            if (dir == ParameterDirection.Input)
            {
                db.AddInParameter(comm, Parametername, dbType, SrcColumn, rowVersion);
            }
           
            //DbParameter cmd = comm.CreateParameter();
            //cmd.ParameterName = Parametername;
            ////  cmd.Value = value;
            //cmd.SourceColumn = SrcColumn;
            //cmd.Direction = dir;
            //cmd.DbType = dbType;
            //cmd.SourceVersion = rowVersion;
            //return (cmd);
        }

        # endregion
    }
}
