using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.IO;
using System.Diagnostics;
using System.Configuration;
using System.Data.SqlClient;
using System.Data;
using Microsoft.Practices.EnterpriseLibrary.Caching;
using Microsoft.Practices.EnterpriseLibrary.Caching.Expirations;
using System.Data.Common;

namespace FileSourceAppCachingTests
{
    /// <summary>
    /// Summary description for CachingAppTestFixture
    /// </summary>
    [TestClass]
    public class CachingAppTestFixture
    {
        public CachingAppTestFixture()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [TestMethod]
        public void CachingInMemoryStoreAppTest()
        {
            CacheManager itemCache = CacheFactory.GetCacheManager("DefaultCacheManager");
            if (itemCache != null)
                itemCache.Flush();
            
            itemCache.Add("1", 1);

            int writtenItem = (int)itemCache.GetData("1");
            Assert.AreEqual(1, writtenItem);
        }

        [TestMethod]
        public void CachingIsolatedStoreAppTest()
        {
            CacheManager itemCache = CacheFactory.GetCacheManager("IsolatedCacheManager");

            if (itemCache != null)
                itemCache.Flush();
            itemCache.Add("2", 2);

            int writtenItem = (int)itemCache.GetData("2");
            Assert.AreEqual(2, writtenItem);
            
        }

        [TestMethod]
        public void DBStoreAddDefaultAppTest()
        {
            int count = 0;
            CacheManager itemCache = CacheFactory.GetCacheManager("DBCacheManager");
            if (itemCache != null)
                itemCache.Flush();
            itemCache.Add("3", 3);

            int writtenItem = (int)itemCache.GetData("3");
            Assert.AreEqual(3, writtenItem);
            
            SqlConnection conn = new SqlConnection();
            conn.ConnectionString = "server=.\\sqlexpress;initial catalog=caching;integrated security=SSPI";
            conn.Open();

            SqlCommand cmd = new SqlCommand("select * from CacheData where [key] in ('3') and PartitionName = 'Partition4'", conn);
            SqlDataReader dr = cmd.ExecuteReader();
            while (dr.Read())
            {
                count = count + 1;
            }
            Assert.AreEqual(1, count);

            dr.Close();
            conn.Close();
        }
    }
}
