using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics; 
using System.Collections.Specialized;
using Microsoft.Practices.EnterpriseLibrary.Logging.Filters;
using Microsoft.Practices.EnterpriseLibrary.Logging.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration.ObjectBuilder;   

namespace CustomClasses
{
    [ConfigurationElementType(typeof(CustomLogFilterData))]
    public class CustomSeverityFilter:LogFilter  
    {
        private NameValueCollection collection;

        public CustomSeverityFilter(System.Collections.Specialized.NameValueCollection collection)
            : base("CustomSeverityFilter")
        {
            this.collection = collection; 
        }

        public override bool  Filter(Microsoft.Practices.EnterpriseLibrary.Logging.LogEntry log)
        {
            if (collection.Count == 0) throw new ApplicationException("Please specify atleast one attribute in the configuration"); 
            foreach (string key in collection.Keys)
            {
                if (collection.Get(key).Equals(log.Severity.ToString()))
                    return true;
            }
            return false; 
        }

    }
}
