using System;
using System.Collections.Generic;
using System.Collections.Specialized;  
using System.Text;
using Microsoft.Practices.EnterpriseLibrary.Logging.Formatters;
using Microsoft.Practices.EnterpriseLibrary.Logging.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration;
namespace CustomClasses
{
    [ConfigurationElementType(typeof(CustomFormatterData))]  
    public class CustomFormatter:TextFormatter 
    {
        public CustomFormatter()
            : base("Timestamp: {timestamp}{newline}Message: {message}{newline}Category: {category}{newline}CategoryID: {categoryid}{newline}Priority: {priority}{newline}EventId: {eventid}{newline}Severity: {severity}{newline}Title:{title}{newline}Machine: {machine}{newline}App Domain: {appDomain}{newline}ProcessId: {processId}{newline}Process Name: {processName}{newline}Thread Name: {threadName}{newline}Win32 ThreadId:{win32ThreadId}{newline}Extended Properties: {dictionary({key} - {value}{newline})}")
        {
        }

        public CustomFormatter(NameValueCollection collection)
            : base("Timestamp: {timestamp}{newline}Message: {message}{newline}Category: {category}{newline}CategoryID: {categoryid}{newline}Priority: {priority}{newline}EventId: {eventid}{newline}Severity: {severity}{newline}Title:{title}{newline}Machine: {machine}{newline}App Domain: {appDomain}{newline}ProcessId: {processId}{newline}Process Name: {processName}{newline}Thread Name: {threadName}{newline}Win32 ThreadId:{win32ThreadId}{newline}Extended Properties: {dictionary({key} - {value}{newline})}")
        {
        }

        protected override string Format(StringBuilder templateBuilder, Microsoft.Practices.EnterpriseLibrary.Logging.LogEntry log)
        {
            if (log is CustomLogEntry)
            {
                templateBuilder.Replace("{categoryid}", ((CustomLogEntry)log).CategoryID.ToString());
            }
            else
            {
                templateBuilder.Replace("{categoryid}", "");
            }
            return base.Format(templateBuilder, log);
        }
    }
}
