using System;
using System.Text;
using System.Collections.Generic;
#if !NUNIT
using Microsoft.VisualStudio.TestTools.UnitTesting;
#else
using NUnit.Framework;
using TestClass = NUnit.Framework.TestFixtureAttribute;
using TestInitialize = NUnit.Framework.SetUpAttribute;
using TestCleanup = NUnit.Framework.TearDownAttribute;
using TestMethod = NUnit.Framework.TestAttribute;
#endif
using System.Configuration;
using System.Security.Principal;
using Microsoft.Practices.EnterpriseLibrary.Common;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration.ObjectBuilder;
using Microsoft.Practices.EnterpriseLibrary.Security;
using Microsoft.Practices.EnterpriseLibrary.Security.Configuration;

namespace SecurityCoreFuncTests
{
    /// <summary>
    /// Summary description for AuthorizationRuleObjectCreationDictTestFixture
    /// </summary>
    [TestClass]
    public class AuthorizationRuleObjectCreationDictTestFixture
    {
        private DictionaryConfigurationSource configSource;
        IIdentity identity;
        private static IPrincipal principal;
        public AuthorizationRuleObjectCreationDictTestFixture()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [TestInitialize()]
        public void MyTestInitialize()
        {
            AuthorizationRuleDictSource sourceSection = new AuthorizationRuleDictSource();
            configSource = sourceSection.BuildDictionarySourceSection();
            
            identity = new GenericIdentity("TestUser");
            string[] roles = new string[] { "Manager" };
            principal = new GenericPrincipal(identity, roles);

        }
        
        [TestMethod]
        public void CreateNamedAuthRuleProviderInConfigFileDic()
        {

            AuthorizationProviderFactory authFactory = new AuthorizationProviderFactory(configSource); ;
            AuthorizationProvider authRuleProvider = authFactory.Create("DefaultRuleProviderDic") as AuthorizationProvider;
            Assert.IsNotNull(authRuleProvider);

        }
        [TestMethod]
        public void CreateDefaultAuthRuleProviderFromConfigFileDic()
        {
            AuthorizationProviderFactory authFactory = new AuthorizationProviderFactory(configSource);
            AuthorizationProvider authRuleProvider = authFactory.CreateDefault() as AuthorizationProvider;
            Assert.IsNotNull(authRuleProvider);

        }

        [TestMethod]
        [ExpectedException(typeof(ConfigurationErrorsException))]
        public void CreateInvalidAuthRuleProviderFromConfigFileDic()
        {
            AuthorizationProviderFactory authFactory = new AuthorizationProviderFactory(configSource);
            AuthorizationProvider authRuleProvider = authFactory.Create("InvalidRule") as AuthorizationProvider;
        }
        
    }
}
